=== perf/CMakeLists.txt ===
add_executable(counted_insertion_sort counted_insertion_sort.cpp)

add_executable(sort_patterns sort_patterns.cpp)
