=== debian/changelog ===
range-v3 (0.3.0-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Alexander GQ Gerasiov <gq@debian.org>  Sun, 28 Jan 2018 02:39:03 +0300

range-v3 (0.3.0-1) unstable; urgency=low

  * Initial release (closes: #883235)

 -- Nicholas Guriev <guriev-ns@ya.ru>  Thu, 07 Dec 2017 22:37:52 +0300
