=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

# The build process is not needed to install headers, and we can skip a
# compilation given tests haven't performed.
override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_SKIP_INSTALL_ALL_DEPENDENCY=ON

# Make the online documentation if the `nodoc` flag isn't specified.
override_dh_auto_build:
ifeq (,$(filter nodoc, $(DEB_BUILD_OPTIONS)))
	dh_auto_build -- doc
endif

# The `test` target doesn't compile tests by itself and fails if they aren't
# built before.
override_dh_auto_test:
ifeq (,$(filter nocheck, $(DEB_BUILD_OPTIONS)))
	dh_auto_build
	dh_auto_test
endif
